#include "IR.h"

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++
[ ʐMݒ ]
    ԊORMW[(CRVP1738)
    ʐMx 2400bps(max) = 417usec/bit
    
    JEgl0xFFƂꍇA417 / (0xFF x 0.2usec) = 8.14
    ăvXP[8傫ȂĂ͂ȂȂ
    
    ܂A417usec / (16 x 0.2usec) = 130.3
    ƂȂ邽߁AJEgl130ȉɐݒ肵Ă͂ȂȂ
++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

// ԊOR
#define ERR_RANGE    2    // rbg e덷 [JEg]
#define BIT_MAX      32   // rbg ől (ύX͎Mobt@̌^ύX邱)
#define MAKER_MAX    6    // Ή[J[

#define BIT_START    0
#define BIT_HI       1
#define BIT_LO       2


int32 IR_ReceiveData;  // ԊO Mf[^
int   IR_count;        // JEg    

short IR_ReceiveIF  = FALSE;    // MtO
short IR_lengthAna  = FALSE;    // rbg ̓tO


// =====================================================================
// ԊOR M
#ifdef IR_CCP1
    #INT_CCP1
#else
    #INT_EXT
#endif
void IntReceive()
{
    static int count;     // Mrbg
    static int32 Signal;  // Mobt@
    int Data;
    int detect;
    
    Data = get_timer0();
    set_timer0(0x00);
    
    // rbg ̓[hH
    if(IR_lengthAna)
    {
        IR_count = Data;
        IR_ReceiveIF = TRUE;    // MtOZbg

        return;
    }
    
    // rbg 
    if     (AllowArea(Data, RC_HI   )) detect = BIT_HI;
    else if(AllowArea(Data, RC_LO   )) detect = BIT_LO;
    else if(AllowArea(Data, RC_START)) detect = BIT_START;
    else return;    // mCYƔf

    // X^[grbgH
    if(detect == BIT_START)
    {
        #ifdef IR_LED_REV
            output_high(IR_LED);
        #else
            output_low(IR_LED);
        #endif

        Signal = 0x00000000;
        count = 0;

        return;
    }
    count++;    // rbgJEg
    
    // MtH[}bg̃rbgBIT_MAX 傫Ȃ
    // 𒴂ŏ̃rbgǂݔ΂
    if(RC_BIT_SUM > BIT_MAX)
    {
        if(count <= RC_BIT_SUM - BIT_MAX)
        {
            return;
        }
    }
        
    switch(detect) {
        case BIT_HI:    Signal <<= 1; Signal++;  break;    // High
        case BIT_LO:    Signal <<= 1;            break;    // Low
        default:
    }
    
    if(count == RC_BIT_SUM)
    {
        IR_ReceiveData = Signal;
        IR_ReceiveIF = TRUE;         // MtOZbg

        #ifdef IR_LED_REV
            output_low (IR_LED);    // kdc_
        #else
            output_high(IR_LED);    // kdc
        #endif
    }
}


// =====================================================================
// Mf[^̉(ԊOR)

#ifdef RC_ANA
int RC_AnalyzeData(int CheckData)
{
    IR_ReceiveIF = FALSE;    // tONA
    
    switch(CheckData) {        // R[h
        case RC_CODE_01:        return  1;    // Button[ 1]
        case RC_CODE_02:        return  2;    // Button[ 2]
        case RC_CODE_03:        return  3;    // Button[ 3]
        case RC_CODE_04:        return  4;    // Button[ 4]
        case RC_CODE_05:        return  5;    // Button[ 5]
        case RC_CODE_06:        return  6;    // Button[ 6]
        case RC_CODE_07:        return  7;    // Button[ 7]
        case RC_CODE_08:        return  8;    // Button[ 8]
        case RC_CODE_09:        return  9;    // Button[ 9]
        case RC_CODE_10:        return 10;    // Button[10]
        case RC_CODE_11:        return 11;    // Button[11]
        case RC_CODE_12:        return 12;    // Button[12]        
        case RC_CODE_VolUP:     return 13;    // Button[VolUP  ]
        case RC_CODE_VolDOWN:   return 14;    // Button[VolDown]
        case RC_CODE_ChUP:      return 15;    // Button[ChannelUP  ]
        case RC_CODE_ChDOWN:    return 16;    // Button[ChannelDown]

        default:                return 0x00;    // YȂ
    }
}
#endif    

// =====================================================================
// ԊOʐM̏
void InitIR()
{
    setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256);    // ^C}Oݒ

#ifdef IR_CCP1
    setup_ccp1(CCP_CAPTURE_FE);     // CCP1 (CRVP1738 ͕_)
    enable_interrupts(INT_CCP1);    // 荞݋
#else
    ext_int_edge(H_TO_L);           // OINT
    enable_interrupts(INT_EXT);     // 荞݋
#endif
    
#ifdef IR_LED_REV
    output_low (IR_LED);    // kdc_
#else
    output_high(IR_LED);    // kdc
#endif
}

// =====================================================================
// 덷 e۔
short AllowArea(int Object, int Scope)
{
    if(Scope - ERR_RANGE > Object) return FALSE;
    if(Scope + ERR_RANGE < Object) return FALSE;
    return TRUE;    
}
